*234567890123456789012345678901234567890123456789012345678901234567890123456789012345678

	program PLOTDUSTY

c     Martin Groenewegen  20 July 2009
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c     gfortran -fbounds-check -O -o PlotMyDusty.exe PlotMyDusty.f -lpgplot 

c    PlotMyDusty.exe cwleo_in   

c ======================================================================================

        implicit double precision(a-h,o-z)

        parameter (npL=306, no=129, ns= 1900)

        double precision wve(npl+1),flx(npl+1),ysel(no),zsel(no)
        double precision xspec(ns),yspec(ns),zspec(ns)
        integer xsel(no),nfl,nsel,nspec
        real  specmin(4), specmax(4), exmin(10),exmax(10),dyn
	double precision irsscale, irserrscale

	character*80 rtinname,starname,name,path
	character*35 cdum

	common/pltlim/wvemin,wvemax,dyn,specmin,specmax,cmin,cmax,npspec
	common/fnames/starname,wavecut
        common/observations/wve,flx,ysel,zsel,xspec,yspec,zspec,xsel,
     c                      nfl,nsel,nspec
	common /global/ irsscale,irserrscale,exmin,exmax, nexl

c ======================================================================================

c     open file that contains parameters to drive the plot
	open(10, file= 'Plotlimits.dat')
c       4 header lines
	do i=1,4
	  read(10,*) name
	enddo
c       SED is plotted between these wavelengths
	read(10,*) wvemin, wvemax
c       Y-Range for SED is between ymax-DYN,ymax+0.5 (in log units)
	read(10,*) dyn
c       Number of plotwindows with spectra
	read(10,*) npspec
c       for each, read min and max wavelength
	do i=1,npspec
	   read(10,*) specmin(i), specmax(i)
	enddo
c       model and spectral observations are scaled to each other based on the 
c       average flux in this wavelenght interval
	read(10,*) cmin, cmax
	close(10)

c ======================================================================================

c     read filename with all inputs
	call getarg (1, rtinname)

c     open it and read in parameters/data, etc
	open(10, file= rtinname)

c     root name of object. Most in- and out-put files are based on this root-name
	read(10,'(a80)') starname
        close(10)

	open(10, file= 'wavecut')
        read(10,*) wavecut
	if (wavecut .le. 0.) wavecut= 0.001
	write(*,*) 'wavecut ' , wavecut
        close(10)

c       for debugging
        CALL Clean(starname, path, lpath)                                      
        CALL ATTACH(path,lpath,'_debugplot.dat',name)

	open(80,file= name)

c       read in observed magnitudes and error (subroutine from MyDusty)
c       xsel contains the index to that magnitude in the model
	call readphot(xsel,ysel,zsel,nsel)
	do i= 1,nsel
   	   write(80,*)'pht', i, nsel,xsel(i),ysel(i),zsel(i)
c   	   write(*,*)'pht', i, nsel,xsel(i),ysel(i),zsel(i)
	enddo

c	read in observed spectra (subroutine from MyDusty)
	call readspec(xspec,yspec,zspec,nspec)
	do i= 1,nspec
     	  write(80,*)'spc',i,nspec,xspec(i),yspec(i),zspec(i)
	enddo

c     read in model flux
        CALL Clean(starname, path, lpath)                                  
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)                                          
        CALL ATTACHfront(path,lpath,'rted_',name)
        open(21, file= name)
        write(*,*) 'read model ', name, nsel

        i=0
 100    i=i+1
c     flux in W/m2
  	read(21,*, err=101,end=101) wve(i), flx(i)
c     W/m2/mu
        flx(i)= flx(i)/wve(i)
        write(80,*) 'model ', i,wve(i), flx(i)
        goto 100
 101    continue
        close(21)
        nfl= i-1

c     read in spec*.dat
        CALL Clean(starname, path, lpath)                                       
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)                                          
        CALL ATTACHfront(path,lpath,'spec_',name)
        open(31, file= name)
        write(*,*) 'read spec info ', name

	nexl= 0
	read(31,*) idum
	do i=1,idum
	   read(31, '(a35)') cdum
	   read(31,*) idum, irsscale, irserrscale
	   read(31,*) nex
	   do j=1,nex
	      nexl= nexl+1
	      read(31,*) exmin(nexl),exmax(nexl)
	      write(*,*) i,j,nexl, exmin(nexl),exmax(nexl)
	   end do
	enddo

	close(31)

        call plotsed

        close(80)

        stop
        end
*23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE Attach(root,length,ext,fname)                                  
c     Attaches extensions to the root cleaned by Clean                          
c =======================================================================       
      CHARACTER*(*) root, ext, fname                                            
      INTEGER i, length                                                         
c -----------------------------------------------------------------------       
      DO i = 1, LEN(fname)                                                      
        fname(i:i) = ' '                                                        
      END DO                                                                    
      fname(:length) = root(:length)                                            
      fname(length + 1:) = ext                                                  
c -----------------------------------------------------------------------       
      RETURN                                                                    
      END                                                                       
c ***********************************************************************       

      SUBROUTINE AttachFront(root,length,ext,fname)                            
c     Adds a string in front of the root cleaned by Clean              
c =======================================================================       
      CHARACTER*(*) root, ext, fname                                            
      INTEGER i, length                                                         
c -----------------------------------------------------------------------       
      DO i = 1, LEN(fname)                                                      
        fname(i:i) = ' '                                                        
      END DO                                                                    
      fname(:LEN(ext)) = ext
      fname(LEN(ext)+1:LEN(ext)+1+length) = root(:length)

      RETURN                                                                    
      END                                                                       
c ***********************************************************************       
                                                                                
      SUBROUTINE Clean(StrIn, StrOut, Length)                                   
c =======================================================================       
c     Find meaningful part of StrIn without leading and trailing junk           
c     It is returned left-justified in StrOut, right-padded with blanks         
c     The number of meaningful characters is returned in Length.                
c     In case of any problems, StrOut is empty. This sub should be used to      
c     clean every input filename immediately after DUSTY reads it. [ME,'99]     
c =======================================================================       
      CHARACTER*(*) StrIn, StrOut                                               
      INTEGER i, first, last, Length                                            
c -----------------------------------------------------------------------       
      DO i = 1, LEN(StrOut)                                                     
        StrOut(i:i) = ' '                                                       
      END DO                                                                    
      first = 1                                                                 
      last = LEN(StrIn)                                                         
      If (first.gt.last) return                                                 
c     Find end of leading junk:                                                 
      DO WHILE (StrIn(first:first).LE.' ')                                      
       first = first + 1                                                        
       if (first.gt.last) return                                                
      END DO                                                                    
c     Find start of trailing junk:                                              
      DO WHILE (StrIn(last:last).LE.' ')                                        
       last = last - 1                                                          
       if (last.lt.first) return                                                
      END DO                                                                    
c     Now trim all junk:                                                        
      StrOut = StrIn(first:last)                                                
      Length = last - first + 1                                                 
c -----------------------------------------------------------------------       
      RETURN                                                                    
      END                                                                       
c ***********************************************************************       
                                                                               
*23456789012345678901234567890123456789012345678901234567890123456789012

        subroutine plotsed

c     plot SED + spectra

        implicit double precision(a-h,o-z)
	parameter(npL=306, no=129, ns= 1900)

        double precision wve(npL+1), flx(npL+1),ysel(no),zsel(no)
        real xpl(ns), ypl(ns), zpl(ns), xpl1(ns), ypl1(ns)

        double precision xspec(ns),yspec(ns),zspec(ns), zpl1(ns)

        real specmin(4), specmax(4)
	real exmin(10),exmax(10)
	double precision irsscale, irserrscale

	integer symbol(ns), xsel(no), idx(ns), nsel,nfl,nspec
	
	real xmin, xmax, ymin, ymax, dyn, wl, ff, er, xx(2), yy(2)
	real vsminx,vsmaxx,vsminy,vsmaxy
	real vsminxi,vsmaxxi,vsminyi,vsmaxyi,x1,x2,y1,y2
        double precision splam(no),spmag(no),sperrmag(no)

	character*80 starname,name,path

	common/pltlim/wvemin,wvemax,dyn,specmin,specmax,cmin,cmax,npspec
	common/fnames/starname,wavecut
        common/observations/wve,flx,ysel,zsel,xspec,yspec,zspec,xsel,
     c                      nfl,nsel,nspec

	common /global/ irsscale,irserrscale,exmin,exmax, nexl
        common/special/splam,spmag,sperrmag,nspc


	write(*,*) 'plotsed', nsel
c     CHANGE, parameters that drive appearance of the plot
c     Plot SED between these wavelengths (mircron)
c	wvemin= 0.2
c	wvemax= 3200.

c     Dynamic range in y for SED
c	dyn= 7.5

c     details of spectral plots. Number and wavelength range.
c        npspec= 1

c        specmin(1)=  5.
c        specmin(1)=  7.5

c        specmax(1)= 40.
c        specmax(1)= 23.

c        specmin(2)=  2.4
c        specmax(2)=  5.

c     scale observed spectra to model, based on average flux in this wavelengtgh region
c        cmin= 8.5
c        cmax= 9.0
c        cmin= 6.4
c        cmax= 6.5

         CALL Clean(starname, path, lpath)
         CALL ATTACH(path,lpath,'_sed.ps/vcps',name)

         call pgbegin(0, name ,1,1)
         call pgscf(2)
         call pgsch(0.75)

c     SED 
        call pgvsize(1.09,5.0,7.7,9.5)

        xmax= -9999.
        xmin=  9999.
c        ymin=  9999.
        ymax= -9999.

c     plot model
        nplt= 0
	sumn= 0.
	sumf= 0.
        do k= 1,nfl
           if (wve(k) .gt. wvemin .and. wve(k) .lt. wvemax) then

              nplt= nplt+1
              xpl(nplt)= log10(wve(k))
              ypl(nplt)= log10(flx(k)*wve(k) )
              if (xpl(nplt) .lt. xmin) xmin= xpl(nplt)
              if (xpl(nplt) .gt. xmax) xmax= xpl(nplt)
c              if (ypl(nplt) .lt. ymin) ymin= ypl(nplt)
              if (ypl(nplt) .gt. ymax) ymax= ypl(nplt)
           endif
           if (wve(k) .gt. cmin .and. wve(k) .lt. cmax) then
              sumn= sumn+ 1
              sumf= sumf+ flx(k)*wve(k)
           endif
        enddo
        avemodel= sumf/sumn


c     plot observed spectrum
c     order by wavelength first to give smooth plots
        call indexx(nspec, xspec, idx)

  	 sumn= 0.
	 sumf= 0.
	 nsp=0
         do i= 1,nspec
	    j= idx(i)
c	    j= i

	    if (yspec(j) .gt. 0.d0) then
	       nsp=nsp+1
	       xpl1(nsp)= log10(xspec(j))
	       ypl1(nsp)= log10(yspec(j) *xspec(j)/1.d5)
	       write(80,*) 'spec', i,nspec, xpl1(nsp),ypl1(nsp)
	       if (ypl1(nsp) .gt. ymax) ymax= ypl1(nsp)
c       write(*,*) 'plot', xspec(i), yspec(i), xpl(i), ypl(i)
	       if (xspec(j) .gt. cmin .and. xspec(j) .lt. cmax) then
		  sumn= sumn+ 1
		  sumf= sumf+ yspec(j) *xspec(j)/1.e5
	       endif
	    endif
         enddo
	if (sumn .eq. 0 .and. nspec .ne. 0) then
	   write(*,*) "check cmin-cmax and range of the spectra!"
	   STOP
	endif


c     observed photometry  (MG 16.09.10 to check maximum only)
         do i= 1,nsel
            call getphot( xsel(i), ysel(i), zsel(i), wl, ff, er )
	    if (log10(ff) .gt. ymax) ymax= log10(ff)
         enddo


	write(*,*) xmin, xmax, ymax-dyn, ymax+0.5
         call pgwindow(xmin, xmax, ymax-dyn, ymax+0.5)
         call pgbox('bcnst',0.0,0,'bcnst',0.0,0)

         call pgline(nplt, xpl, ypl)

         call pglabel('log \gl [\gmm]', 
     c      'log \gl F\d\gl\u [W m\u-2\d]', ' ')


         call pgslw(2)
         call pgline(nsp, xpl1, ypl1)
         call pgslw(1)
         aveobs= sumf/sumn
c	 write(*,*) sumf, sumn


c         write( cwave ,'(f6.1)') waveint(i)
c         call pgtext( xmin+0.5*(xmax-xmin), ymax+1.0 , starname)
         call pgtext( xmin+0.72*(xmax-xmin), ymax-0.5 , starname)


c     plot observed photometry
         do i= 1,nsel
c	    write(*,*) i,xsel(i)
            call getphot( xsel(i), ysel(i), zsel(i), wl, ff, er )

	    isym= 4
	    if (wl .lt. wavecut) isym= 5
            call pgpnts(1, log10(wl), log10(ff), isym, 1)
            call pgerrb(6, 1, log10(wl), log10(ff), 
     c                                   log10(ff+er)-log10(ff), 0.0)
            write(80,*) 'phot ', i,xsel(i),ysel(i),zsel(i),wl,ff,er
         enddo


c     plot one or more spectra
        do i= 1, npspec

        if (i .eq. 1) then
	 vsminx=1.09
	 vsmaxx=5.0
	 vsminy=5.4
	 vsmaxy=7.2
        endif
        if (i .eq. 2) then
	 vsminx=1.09
	 vsmaxx=5.0
	 vsminy=3.1
	 vsmaxy=4.9
        endif
        if (i .eq. 3) then
	 vsminx=1.09
	 vsmaxx=5.0
	 vsminy=0.8
	 vsmaxy=2.6
        endif
	if (i .eq. 4) then
	   write(*,*) 'oeps, 3 spectra are not implemented yet'
	   stop
	endif

        call pgvsize(vsminx,vsmaxx,vsminy,vsmaxy)

c     model
        nplt= 0
        ymin=  9999.
        ymax= -9999.
        do k= 1,nfl
           if (wve(k) .gt. specmin(i)-0.1
     c                 .and. wve(k) .lt. specmax(i)+0.3) then
              nplt= nplt+1
              xpl(nplt)= wve(k)
              ypl(nplt)= flx(k)*wve(k)   /1.e-12
              if (ypl(nplt) .lt. ymin) ymin= ypl(nplt)
              if (ypl(nplt) .gt. ymax) ymax= ypl(nplt)
           endif
        enddo


c     plot observed spectrum scaled to the model
         do j= 1,nspec
	    k= idx(j)
c	    k= j

            xpl1(j)= xspec(k)
            ypl1(j)= yspec(k) *xspec(k)/1.e5  /aveobs*avemodel /1.e-12
            if (ypl1(j) .gt. ymax .and. xpl1(j) .le. specmax(i) .and.
     c          xpl1(j) .gt. specmin(i))        ymax= ypl1(j)
            if (ypl1(j) .lt. ymin .and. xpl1(j) .le. specmax(i) .and.
     c          xpl1(j) .gt. specmin(i))        ymin= ypl1(j)
         enddo

         call pgwindow(specmin(i), specmax(i), ymin*0.9, ymax*1.05)
         call pgbox('bcnst',0.0,0,'bcnst',0.0,0)

	 call pgsls(2)
         call pgline(nplt, xpl, ypl)
	 call pgsls(1)
         call pgline(nspec, xpl1, ypl1)
         call pgslw(1)

         call pglabel(' \gl [\gmm]', 
     c      '\gl F\d\gl\u [10\u-12\d W m\u-2\d]', ' ')

	 call pgsls(1)
	do j= 1,nexl
	   xx(1)= exmin(j)
	   yy(1)= ( ymax*1.05 - ymin*0.9 )*0.05+ ymin*0.9
	   xx(2)= exmax(j)
	   yy(2)= yy(1)
	   write(*,*) j, xx,yy
	   call pgline(2,xx,yy)
	enddo


c     end plot spectra
        enddo

         call pgend

         write(*,*) 'obs model ', aveobs, avemodel

         return
         end
*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine readphot(x,mago,errmag,nobs)

c       read in observed data, and link to predicted ones.
        implicit double precision(a-h,o-z)

	parameter(no=129)
	double precision mag(no), mago(no), errmag(no), l0
        double precision splam(no),spmag(no),sperrmag(no)
	character*6 philnameo(no), nameo, name, cdum
        character fmt*6
	integer x(no)

	character*80 name1,starname,path

	common/fnames/starname,wavecut
        common/special/splam,spmag,sperrmag,nspc

c       observed data
c       file name that needs to exist is called   sed_<starname>.dat
        CALL Clean(starname, path, lpath)                                      
        CALL ATTACH(path,lpath,'.dat',name1)
        CALL Clean(name1, path, lpath)                                          
        CALL ATTACHfront(path,lpath,'sed2_',name1)

	open(23, file= name1)
        write(*,*) 'readphot ',  name1, path
	
c 5	format(a6,1x, f6.3,1x, f5.3)
 5	format(a6,1x, f11.3,1x, f10.3)

        j=0
 100    j=j+1
        read(23, 5 ,err=101,end=101) philnameo(j), mago(j), errmag(j)

        cdum= philnameo(j)
        if ( (cdum(1:1).eq.'1').or.(cdum(1:1).eq.'2').or.
     c       (cdum(1:1).eq.'3').or.(cdum(1:1).eq.'4').or.
     c       (cdum(1:1).eq.'5').or.(cdum(1:1).eq.'6').or.
     c       (cdum(1:1).eq.'7').or.(cdum(1:1).eq.'8').or.
     c       (cdum(1:1).eq.'9').or.(cdum(1:1).eq.'0') ) then

        if ( (cdum(2:2).eq.'1').or.(cdum(2:2).eq.'2').or.
     c       (cdum(2:2).eq.'3').or.(cdum(2:2).eq.'4').or.
     c       (cdum(2:2).eq.'5').or.(cdum(2:2).eq.'6').or.
     c       (cdum(2:2).eq.'7').or.(cdum(2:2).eq.'8').or.
     c       (cdum(2:2).eq.'9').or.(cdum(2:2).eq.'0').or.
     c       (cdum(2:2).eq.'.') ) then

           nspc= nspc+1
           do i= 2,6
              if (cdum(i:i) .eq. '.') k= i
           enddo
           if (k.eq.6) fmt='(f6.0)'
           if (k.eq.5) fmt='(f6.1)'
           if (k.eq.4) fmt='(f6.2)'
           if (k.eq.3) fmt='(f6.3)'
           if (k.eq.2) fmt='(f6.4)'
           read( cdum, fmt) splam(nspc)
           dum= mago(j)+errmag(j)
           spmag(nspc)= log10(mago(j))
           sperrmag(nspc)= log10(dum)-spmag(nspc)
           x(j)= 1000+nspc
           mago(j)= spmag(nspc)
           errmag(j)= sperrmag(nspc)
        endif
        endif

	if (philnameo(j) .eq. '  BesU') x(j)=1
	if (philnameo(j) .eq. '  BesB') x(j)=2
	if (philnameo(j) .eq. '  BesV') x(j)=3
	if (philnameo(j) .eq. '  BesR') x(j)=4
	if (philnameo(j) .eq. '  BesI') x(j)=5

	if (philnameo(j) .eq. 'wfcamZ') x(j)=6
	if (philnameo(j) .eq. 'wfcamY') x(j)=7
	if (philnameo(j) .eq. 'wfcamJ') x(j)=8
	if (philnameo(j) .eq. 'wfcamH') x(j)=9
	if (philnameo(j) .eq. 'wfcamK') x(j)=10

	if (philnameo(j) .eq. 'denisI') x(j)=11
	if (philnameo(j) .eq. 'denisJ') x(j)=12
	if (philnameo(j) .eq. 'denisK') x(j)=13

	if (philnameo(j) .eq. '2massJ') x(j)=14
	if (philnameo(j) .eq. '2massH') x(j)=15
	if (philnameo(j) .eq. '2massK') x(j)=16

	if (philnameo(j) .eq. 'irac36') x(j)=17
	if (philnameo(j) .eq. 'irac45') x(j)=18
	if (philnameo(j) .eq. 'irac58') x(j)=19
	if (philnameo(j) .eq. 'irac80') x(j)=20

	if (philnameo(j) .eq. 'iras12') x(j)=21
	if (philnameo(j) .eq. 'iras25') x(j)=22
	if (philnameo(j) .eq. 'iras60') x(j)=23
	if (philnameo(j) .eq. 'ira100') x(j)=24

	if (philnameo(j) .eq. ' irsfJ') x(j)=25
	if (philnameo(j) .eq. ' irsfH') x(j)=26
	if (philnameo(j) .eq. ' irsfK') x(j)=27

	if (philnameo(j) .eq. '  MSXA') x(j)=28

	if (philnameo(j) .eq. 'caspiJ') x(j)=29
	if (philnameo(j) .eq. 'caspiH') x(j)=30
	if (philnameo(j) .eq. 'caspiK') x(j)=31
	if (philnameo(j) .eq. 'caspiL') x(j)=32

	if (philnameo(j) .eq. 'mips24') x(j)=33
	if (philnameo(j) .eq. 'mips70') x(j)=34
	if (philnameo(j) .eq. 'mip160') x(j)=35

	if (philnameo(j) .eq. ' ogleU') x(j)=36
	if (philnameo(j) .eq. ' ogleB') x(j)=37
	if (philnameo(j) .eq. ' ogleV') x(j)=38
	if (philnameo(j) .eq. ' ogleI') x(j)=39

	if (philnameo(j) .eq. ' casw1') x(j)=40
	if (philnameo(j) .eq. ' calw1') x(j)=41
	if (philnameo(j) .eq. ' calw2') x(j)=42
	if (philnameo(j) .eq. ' calw7') x(j)=43
	if (philnameo(j) .eq. 'calw10') x(j)=44

	if (philnameo(j) .eq. ' saaoJ') x(j)=45
	if (philnameo(j) .eq. ' saaoH') x(j)=46
	if (philnameo(j) .eq. ' saaoK') x(j)=47
	if (philnameo(j) .eq. ' saaoL') x(j)=48

c     I adopted the convention to work in log10(Flux in mJy) for submm/mm wavelenghts
c       (and not in magnitudes; the log is to get a number of same order as magnitudes)
	if (philnameo(j) .eq. 'apx450') then
           x(j)=49
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif  
	if (philnameo(j) .eq. 'apx870') then
           x(j)=50
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ap1200') then
           x(j)=51
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. 'sloanu') x(j)=52
	if (philnameo(j) .eq. 'sloang') x(j)=53
	if (philnameo(j) .eq. 'sloanr') x(j)=54
	if (philnameo(j) .eq. 'sloani') x(j)=55
	if (philnameo(j) .eq. 'sloanz') x(j)=56

	if (philnameo(j) .eq. '  esoJ') x(j)=57
	if (philnameo(j) .eq. '  esoH') x(j)=58
	if (philnameo(j) .eq. '  esoK') x(j)=59
	if (philnameo(j) .eq. '  esoL') x(j)=60
	if (philnameo(j) .eq. '  esoM') x(j)=61


	if (philnameo(j) .eq. 'ukt350') then
           x(j)=62
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt450') then
           x(j)=63
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt600') then
           x(j)=64
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt800') then
           x(j)=65
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt850') then
           x(j)=66
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'uk1100') then
           x(j)=67
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'uk1300') then
           x(j)=68
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'uk2000') then
           x(j)=69
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. 'se1300') then
           x(j)=70
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. '  esoN') x(j)=71
	if (philnameo(j) .eq. ' esoN1') x(j)=72
	if (philnameo(j) .eq. ' esoN2') x(j)=73
	if (philnameo(j) .eq. ' esoN3') x(j)=74
	if (philnameo(j) .eq. ' esoQ0') x(j)=75


	if (philnameo(j) .eq. ' pacsb') then
           x(j)=76
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. ' pacsg') then
           x(j)=77
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. ' pacsr') then
           x(j)=78
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'spire1') then
           x(j)=79
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'spire2') then
           x(j)=80
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'spire3') then
           x(j)=81
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. 'AkarN2') x(j)=82
	if (philnameo(j) .eq. 'AkarN3') x(j)=83
	if (philnameo(j) .eq. 'AkarN4') x(j)=84
	if (philnameo(j) .eq. 'AkarS7') x(j)=85
	if (philnameo(j) .eq. 'AkaS9W') x(j)=86
	if (philnameo(j) .eq. 'AkaS11') x(j)=87
	if (philnameo(j) .eq. 'AkaL15') x(j)=88
	if (philnameo(j) .eq. 'AkL18W') x(j)=89
	if (philnameo(j) .eq. 'AkaL24') x(j)=90
	if (philnameo(j) .eq. 'AkaN60') x(j)=91
	if (philnameo(j) .eq. 'AkarWS') x(j)=92
	if (philnameo(j) .eq. 'AkarWL') x(j)=93
	if (philnameo(j) .eq. 'AkN160') x(j)=94

	if (philnameo(j) .eq. 'vistaZ') x(j)=95
	if (philnameo(j) .eq. 'vistaY') x(j)=96
	if (philnameo(j) .eq. 'vistaJ') x(j)=97
	if (philnameo(j) .eq. 'vistaH') x(j)=98
	if (philnameo(j) .eq. 'vistaK') x(j)=99

	if (philnameo(j) .eq. 'WISE1 ') x(j)=100
	if (philnameo(j) .eq. 'WISE2 ') x(j)=101
	if (philnameo(j) .eq. 'WISE3 ') x(j)=102
	if (philnameo(j) .eq. 'WISE4 ') x(j)=103

	if (philnameo(j) .eq. 'Opg   ') x(j)=104
	if (philnameo(j) .eq. 'Epg   ') x(j)=105
	if (philnameo(j) .eq. 'V495  ') x(j)=106
	if (philnameo(j) .eq. 'JpgBJ ') x(j)=107
	if (philnameo(j) .eq. 'FpgRF ') x(j)=108
	if (philnameo(j) .eq. 'NmagIN') x(j)=109

	if (philnameo(j) .eq. 'PAH1VI') x(j)=110
	if (philnameo(j) .eq. 'PAH2VI') x(j)=111
	if (philnameo(j) .eq. 'SICVI ') x(j)=112

	if (philnameo(j) .eq. 'COBE3 ') then
           x(j)=113
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'COBE4 ')  then
           x(j)=114
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'COBE5 ')  then
           x(j)=115
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

c     some futching to account for variability (based on CWLEO)
c        call getphot( x(j), mag, emag, l0, flux, eflux )
c        scerr= -17.* alog10(l0) +25.821
c        if (scerr .lt. 1.) scerr= 1.0
c        errmag(j)= errmag(j)* scerr

	if (philnameo(j) .eq. '!') goto 101
	if (philnameo(j) .eq. '#') goto 101
	goto 100
 101	continue
	nobs= j-1

	if (nobs .gt. no) then
           write(*,*) 'INCREASE no'
           STOP
        endif

	close(23)

	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine readspec(x,mago,errmag,nob)

c       read in observed spectral data
        implicit double precision(a-h,o-z)

	parameter(ns= 1900)
	double precision mag(ns), mago(ns), errmag(ns)
	double precision x(ns), xlow(ns), xup(ns)
	double precision dumx(ns), dumy(ns), dumz(ns), ord(ns)
	integer in

	data xlow /ns*0.0/
	data xup  /ns*9999./

	character*80 starname,specname,path,name,cdum

	common/fnames/starname,wavecut

c       observed data
c       file name that needs to exist is called   spec_<starname>.dat
        CALL Clean(starname, path, lpath)                                          
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)                                          
        CALL ATTACHfront(path,lpath,'spec_',name)

        write(*,'(A)') 'readspec ',  name, path

	nob= 0
	write(80,*) 'readspec'

c       observed data
	open(23, file= name)

c       number of spectra
	read(23,*) nns
	write(80,*) nns

	do I= 1,NNS

c       filename
	read(23,'(a80)') specname
	write(80,*) '|',specname,'|'

c	read CODE, scaling flux, scaling errorbar
c       CODE gives option to have different input formats, hardcoded later
	read(23,*) IC, sf, se

c       read number of excluded segments
	read(23,*) nex
	write(80,*) IC, sf, se, nex
c       read lower and upper wavelength interval, in units of inputfile
	do  J= 1,NEX
	   read(23,*) xlow(j), xup(j)
	   write(80,*) j,xlow(j), xup(j)
	enddo

	open(33, FILE= specname)

	if (IC .eq. 1) then
c       IRS spectra
c       format: wave(mu), flux(Jy), errflux(Jy), order
	k=1
 111	read(33,*, err=112,end=112) dumx(k), dumy(k), dumz(k),ord(k)
	write(80,*) k,dumx(k), dumy(k), dumz(k), ord(k)

	k=k+1
	goto 111
 112	continue
	np= k-1

c       check if point is in excluded wavelength region
	do k= 1,np
	   in= 1
	   do j= 1,nex
c	      if((dumx(k) .gt. xlow(j)).and.(dumx(k) .lt. xup(j))) in=0
	   enddo

c       MG 20.08.08 require positive flux, and non-zero errorbar as well
c       MG 20.07.09 For plotting take all
	   if ((in .ge. -1) .and. (1. .gt. 0.0) 
     c                      .and. (1. .gt. 0.0)) then
c       OK, convert (if needed) wavelength to micron, and flux(error) to W/m2/mu,
c           scale flux and errors according to inputfile, and add this point.
	      nob= nob+1
	      x(nob)= dumx(k)
	      mago(nob)= dumy(k)     *2.99792458e-12/dumx(k)/dumx(k)
              dum= (dumy(k)+dumz(k)) *2.99792458e-12/dumx(k)/dumx(k)
              errmag(nob)= dum-mago(nob)
c       MG 20.08.08 scale flux and error with 1.e5 to avoid underflows
	      mago(nob)= mago(nob)     *sf *1.0e5
	      errmag(nob)= errmag(nob) *se *1.0e5
	   endif
	enddo

c       end IRS spectra
	endif

	if (IC .eq. 2) then
c       SWS LWS spectra; assume 5% errorbar
c       format: wave(mu), flux(Jy)
	k=1
 211	read(33,*, err=212,end=212) dumx(k), dumy(k), dumz(k)
        if (dumz(k) .eq. 0.) dumz(k)= 0.05* dumy(k)
	write(80,*) IC, k,dumx(k), dumy(k), dumz(k)

	k=k+1
	goto 211
 212	continue
	np= k-1

c       check if point is in excluded wavelength region
	do k= 1,np
	   in= 1
	   do j= 1,nex
c	      if((dumx(k) .gt. xlow(j)).and.(dumx(k) .lt. xup(j))) in=0
	   enddo

	   if ((in .eq. 1) .and. (1.0 .gt. 0.0))  then
c	   if ((in .ge. -1) .and. (1.0 .gt. 0.0))  then
c       OK, convert (if needed) wavelength to micron, and flux(error) to W/m2/mu,
c           scale flux and errors according to inputfile, and add this point.
	      nob= nob+1
	      x(nob)= dumx(k)
	      mago(nob)= dumy(k)     *2.99792458e-12/dumx(k)/dumx(k)
              dum= (dumy(k)+dumz(k)) *2.99792458e-12/dumx(k)/dumx(k)
              errmag(nob)= dum-mago(nob)
c       MG 20.08.08 scale flux and error with 1.e5 to avoid underflows
	      mago(nob)= mago(nob)     *sf *1.0e5
	      errmag(nob)= errmag(nob) *se *1.0e5
	   endif
	enddo

c       end SWS LWS spectra
	endif

	if (IC .eq. 3) then
c       IRAS LRS spectra, as from Calgary database; assume 5% errorbar
c       format: wave(mu), flux W/m2/mu
c       first part spectrum
	read(33,*) cdum
	k=1
 311	read(33,*, err=312,end=312) dumx(k), dumy(k)
	write(80,*) IC, k,dumx(k), dumy(k)

	k=k+1
	goto 311
 312	continue
c       second part spectrum
 313	read(33,*, err=314,end=314) dumx(k), dumy(k)
	write(80,*) IC, k,dumx(k), dumy(k)

	k=k+1
	goto 313
 314	continue
	np= k-1

c       check if point is in excluded wavelength region
	do k= 1,np
	   in= 1
	   do j= 1,nex
c	      if((dumx(k) .gt. xlow(j)).and.(dumx(k) .lt. xup(j))) in=0
	   enddo

c	   if ((in .ge. -1) .and. (1.0 .gt. 0.0))  then
	   if ((in .eq. 1) .and. (1.0 .gt. 0.0))  then
c       OK, convert (if needed) wavelength to micron, and flux(error) to W/m2/mu,
c           scale flux and errors according to inputfile, and add this point.
	      nob= nob+1
	      x(nob)= dumx(k)
	      mago(nob)= dumy(k)
              dum= (dumy(k)+0.05*dumy(k))
              errmag(nob)= dum-mago(nob)
c       MG 20.08.08 scale flux and error with 1.e5 to avoid underflows
	      mago(nob)= mago(nob)     *sf *1.0e5
	      errmag(nob)= errmag(nob) *se *1.0e5
	   endif
	enddo

c       end IRAS LRS spectra
	endif


	close(33)
	if (nob .gt. ns) then
           write(*,*) 'INCREASE ns'
           STOP
        endif

c       end loop spectra
	ENDDO

	do i=1,nob
	   write(80,*) 'spec ', i, x(i), mago(i), errmag(i)
	enddo

	close(23)

	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE indexx(n,arr,indx)

      INTEGER n,indx(n),M,NSTACK
      DOUBLE PRECISION arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      DOUBLE PRECISION a
      do 11 j=1,n
        indx(j)=j
11    continue
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 13 j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do 12 i=j-1,1,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
12        continue
          i=0
2         indx(i+1)=indxt
13      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(l)))then
          itemp=indx(l+1)
          indx(l+1)=indx(l)
          indx(l)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END

*23456789012345678901234567890123456789012345678901234567890123456789012

        subroutine getphot( isel, mag, emag, l0, flux, eflux )

c     based on index of available filters, magnitude and error, return
c     the effective wavelength and flux with error.

c     available filters, effective wavelengths and zeropoints have to be in sync 
c     with PSCfoldORIG
        implicit double precision(a-h,o-z)

	parameter(no=129)

        integer isel
        double precision mag
	real flux, l0, eflux

        double precision splam(no),spmag(no),sperrmag(no)
        common/special/splam,spmag,sperrmag,nspc


        l0=    1.e9
        flux=  1.e9
        eflux= 0.

	write(*,*) 'getph ', isel, mag, emag, nspc
	if (isel .ge. 1000) then
	   j= isel-1000
	   l0= splam(j)

	   dum= 2.9979e-15/l0/l0* 10**mag 
	   flux= dum
	   dum= 2.9979e-15/l0/l0* 10**(mag+emag)
	   eflux= dum - flux

	endif

c     1-5 Bessell UBVRI
        if (isel .eq. 1) then
           l0= 0.366
           zp= 4.400e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 2) then
           l0= 0.438
           zp= 6.418e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 3) then
           l0= 0.545
           zp= 3.688e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 4) then
           l0= 0.641
           zp= 2.205e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 5) then
           l0= 0.798
           zp= 1.142e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     6-10 WFCAM ZYJHK
        if (isel .eq. 6) then
           l0= 0.8817
           zp= 8.807e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 7) then
           l0= 1.0305
           zp= 5.834e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 8) then
           l0= 1.2483
           zp= 3.022e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 9) then
           l0= 1.6313
           zp= 1.165e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 10) then
           l0= 2.2010
           zp= 4.018e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     11-13 DENIS IJK
        if (isel .eq. 11) then
           l0= 0.791
           zp= 11.82e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 12) then
           l0= 1.228
           zp= 3.19e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 13) then
           l0= 2.145
           zp= 4.38e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     14-16 2MASS JHK
        if (isel .eq. 14) then
           l0= 1.235
           zp= 3.137e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 15) then
           l0= 1.662
           zp= 1.117e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 16) then
           l0= 2.159
           zp= 4.312e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     17-20 IRAC 36 45 58 80
        if (isel .eq. 17) then
           l0= 3.55
           zp= 6.63e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 18) then
           l0= 4.49
           zp= 2.67e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 19) then
           l0= 5.73
           zp= 10.81e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 20) then
           l0= 7.87
           zp= 3.08e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     21-24 IRAS 12 25 60 100
        if (isel .eq. 21) then
           l0= 12.
           zp= 40.1 *2.998e-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 22) then
           l0= 25.
           zp= 8.81 *2.998e-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
         endif

        if (isel .eq. 23) then
           l0= 60.
           zp= 1.57 *2.998e-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 24) then
           l0= 100.
           zp= 0.405 *2.998e-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     25-27 IRSF JHK
        if (isel .eq. 25) then
           l0= 1.250
           zp= 3.036e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 26) then
           l0= 1.664
           zp= 1.170e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 27) then
           l0= 2.149
           zp= 4.45e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     28    MSX A
        if (isel .eq. 28) then
           l0= 8.28
           zp= 2.364e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     29-32 CASPIR JHKL
        if (isel .eq. 29) then
           l0= 1.24
           zp= 3.182e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 30) then
           l0= 1.68
           zp= 1.085e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 31) then
           l0= 2.22
           zp= 3.993e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 32) then
           l0= 3.59
           zp= 6.306e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     33-35 MIPS 24 70 160
        if (isel .eq. 33) then
           l0= 24.0
           zp= 3.76e-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 34) then
           l0= 70.0
           zp= 4.84e-16

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 35) then
           l0= 160.0
           zp= 2.23e-17

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     36-39 OGLE UBVI
        if (isel .eq. 36) then
           l0= 0.372
           zp= 4.559e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 37) then
           l0= 0.431
           zp= 6.404e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 38) then
           l0= 0.536
           zp= 3.844e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 39) then
           l0= 0.820
           zp= 1.060e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     40-44 ISOCAM SW1 LW1,2,7,10
        if (isel .eq. 40) then
           l0= 3.6
           zp= 6.508e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 41) then
           l0= 4.5
           zp= 2.692e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 42) then
           l0= 6.7
           zp= 6.028e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 43) then
           l0= 9.6
           zp= 1.384e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 44) then
           l0= 12.0
           zp= 7.233e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     45-48 SAAO JHKL
        if (isel .eq. 45) then
           l0= 1.23
           zp= 3.255e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 46) then
           l0= 1.66
           zp= 1.132e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 47) then
           l0= 2.23
           zp= 3.892e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 48) then
           l0= 3.44
           zp= 7.499e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     49-51 'APEX' 450, 870, 1200 (scuba 450/ LABOCCA 870/ MAMBO 1200) [milliJy]
        if (isel .eq. 49) then
           l0= 450.
           zp= 2.613e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 50) then
           l0= 870.
           zp= 1.986e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 51) then
           l0= 1200.
           zp= 5.573e-21

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif


c     52-56 Sloan ugriz
        if (isel .eq. 52) then
           l0= 0.3551
           zp= 41.00e-9

           dum=10**(-0.4*(mag-0.808))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.808-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 53) then
           l0= 0.4686
           zp= 55.82e-9

           dum=10**(-0.4*(mag+0.129))
           flux= zp*dum
           dum=10**(-0.4*(mag+0.129-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 54) then
           l0= 0.6165
           zp= 25.52e-9

           dum=10**(-0.4*(mag-0.125))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.125-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 55) then
           l0= 0.7482
           zp= 14.23e-9

           dum=10**(-0.4*(mag-0.340))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.340-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 56) then
           l0= 0.8931
           zp= 8.526e-9

           dum=10**(-0.4*(mag-0.511))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.511-emag))
           eflux= zp*dum - flux
        endif


c     57-61 ESO JHKLM
        if (isel .eq. 57) then
           l0= 1.228
           zp= 2.907e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 58) then
           l0= 1.651
           zp= 1.133e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 59) then
           l0= 2.216
           zp= 4.025e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 60) then
           l0= 3.771
           zp= 5.125e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 61) then
           l0= 4.772
           zp= 2.217e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     62-69 UKT14 350,450,600,800,850,1100,1300,2000 micron [milliJy]
        if (isel .eq. 62) then
           l0= 350.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 63) then
           l0= 443.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 64) then
           l0= 647.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 65) then
           l0= 790.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 66) then
           l0= 850.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 67) then
           l0= 1102.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 68) then
           l0= 1259.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 69) then
           l0= 1921.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c       70 SEST single-channel
        if (isel .eq. 70) then
           l0= 1300.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c       71-75 ESO mid-IR bolometer
        if (isel .eq. 71) then
           l0= 9.68
           zp= 1.202e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 72) then
           l0= 8.36
           zp= 2.420e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 73) then
           l0= 9.79
           zp= 1.302e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 74) then
           l0= 12.82
           zp= 4.132e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 75) then
           l0= 18.67
           zp= 1.029e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c       76-81 PACS blue, green, red; SPIRE band 1,2,3
        if (isel .eq. 76) then
           l0= 69.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 77) then
           l0= 98.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 78) then
           l0= 153.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 79) then
           l0= 250.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 80) then
           l0= 350.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 81) then
           l0= 500.
           zp= 1.e-19

           dum= 2.9979e-15/l0/l0* 10**mag 
           flux= dum
           dum= 2.9979e-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c       Akari  IRC (82-84) MIR-S MIR-L FIS
        if (isel .eq. 82) then
           l0= 2.69
           zp= 2.75e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 83) then
           l0= 3.06
           zp= 1.106e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 84) then
           l0= 4.55
           zp= 2.836e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 85) then
           l0= 8.0
           zp= 3.96e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 86) then
           l0= 10.04
           zp= 1.72e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 87) then
           l0= 10.0
           zp= 9.989e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 88) then
           l0= 17.5
           zp= 1.742e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 89) then
           l0= 17.6
           zp= 1.042e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 90) then
           l0= 23.55
           zp= 4.085e-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 91) then
           l0= 65.
           zp= 6.46e-16

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 92) then
           l0= 90.
           zp= 2.24e-16

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 93) then
           l0= 140.
           zp= 2.96e-17

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 94) then
           l0= 160.
           zp= 1.95e-17

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     95-99 VISTA ZYJHK
        if (isel .eq. 95) then
           l0= 0.876
           zp= 8.905d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 96) then
           l0= 1.018
           zp= 6.053d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 97) then
           l0= 1.246
           zp= 3.022d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 98) then
           l0= 1.631
           zp= 1.150d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 99) then
           l0= 2.133
           zp= 4.476d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     WISE 1,2,3,4 filters
        if (isel .eq. 100) then
           l0= 3.353
           zp= 8.12e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 101) then
           l0= 4.603
           zp= 2.39e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 102) then
           l0= 11.56
           zp= 6.100e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 103) then
           l0= 22.09
           zp= 4.93e-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     Photographic magnitudes 104-109
        if (isel .eq. 104) then
           l0= 0.42
           zp= 5.69e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 105) then
           l0= 0.64
           zp= 2.21e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 106) then
           l0= 0.56
           zp= 3.33e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 107) then
           l0= 0.47
           zp= 5.31e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 108) then
           l0= 0.66
           zp= 2.08e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (isel .eq. 109) then
           l0= 0.83
           zp= 1.03e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     ESO VISIR 110-112
        if (isel .eq. 110) then
           l0= 8.59
           zp= 2.110e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 111) then
           l0= 11.25
           zp= 7.296e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (isel .eq. 112) then
           l0= 11.85
           zp= 6.148e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     COBE filters 3,4,5: 113-115
        if (isel .eq. 113) then
           l0= 3.57
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 114) then
           l0= 4.93
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (isel .eq. 115) then
           l0= 12.71
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c     convert to W/m2
        flux=  flux *l0
        eflux= eflux*l0

        return
        end

*23456789012345678901234567890123456789012345678901234567890123456789012

